package org.jacorb.notification.engine;

/*
 *        JacORB - a free Java ORB
 *
 *   Copyright (C) 1997-2004 Gerald Brose.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Library General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import org.omg.CosEventComm.PushConsumer;
import org.jacorb.notification.interfaces.Message;
import org.omg.CosEventComm.Disconnected;

/**
 * @author Alphonse Bendt
 * @version $Id: PushAnyOperation.java,v 1.2 2004/05/06 12:39:59 nicolas Exp $
 */
public class PushAnyOperation extends PushOperation {

    private PushConsumer pushConsumer_;

    public PushAnyOperation(PushConsumer pushConsumer, Message message) {
        super(message);

        pushConsumer_ = pushConsumer;
    }

    public void invokePush() throws Disconnected {
        pushConsumer_.push(message_.toAny());
    }
}
